# DO NOT EDIT! GENERATED AUTOMATICALLY!
# Copyright (C) 2002-2025 Free Software Foundation, Inc.
#
# This file is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This file is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this file.  If not, see <https://www.gnu.org/licenses/>.
#
# As a special exception to the GNU General Public License,
# this file may be distributed as part of a program that
# contains a configuration script generated by Autoconf, under
# the same distribution terms as the rest of that program.
#
# Generated by gnulib-tool.
#
# This file represents the compiled summary of the specification in
# gnulib-cache.m4. It lists the computed macro invocations that need
# to be invoked from configure.ac.
# In projects that use version control, this file can be treated like
# other built files.


# This macro should be invoked from gettext-tools/configure.ac, in the section
# "Checks for programs", right after AC_PROG_CC, and certainly before
# any checks for libraries, header files, types and library functions.
AC_DEFUN([gttgl_EARLY],
[
  m4_pattern_forbid([^gl_[A-Z]])dnl the gnulib macro namespace
  m4_pattern_allow([^gl_ES$])dnl a valid locale name
  m4_pattern_allow([^gl_LIBOBJS$])dnl a variable
  m4_pattern_allow([^gl_LTLIBOBJS$])dnl a variable

  # Pre-early section.
  AC_REQUIRE([gl_PROG_AR_RANLIB])

  # Code from module extern-inline:
  # Code from module gen-header:
  # Code from module pthread_sigmask:
  # Code from module signal-h:
  # Code from module snippet/arg-nonnull:
  # Code from module snippet/c++defs:
  # Code from module snippet/warn-on-use:
  # Code from module thread:
  # Code from module threadlib:
  gl_THREADLIB_EARLY
  # Code from module windows-thread:
  # Code from module windows-tls:
])

# This macro should be invoked from gettext-tools/configure.ac, in the section
# "Check for header files, types and library functions".
AC_DEFUN([gttgl_INIT],
[
  AM_CONDITIONAL([GL_COND_LIBTOOL], [false])
  gl_cond_libtool=false
  gl_libdeps=
  gl_ltlibdeps=
  gl_m4_base='tests/gnulib-m4'
  m4_pushdef([AC_LIBOBJ], m4_defn([gttgl_LIBOBJ]))
  m4_pushdef([AC_REPLACE_FUNCS], m4_defn([gttgl_REPLACE_FUNCS]))
  m4_pushdef([AC_LIBSOURCES], m4_defn([gttgl_LIBSOURCES]))
  m4_pushdef([gttgl_LIBSOURCES_LIST], [])
  m4_pushdef([gttgl_LIBSOURCES_DIR], [])
  m4_pushdef([GL_MACRO_PREFIX], [gttgl])
  m4_pushdef([GL_MODULE_INDICATOR_PREFIX], [GL_GTTGL])
  gl_COMMON
  gl_source_base='tests/gnulib-lib'
  gl_source_base_prefix=
  AC_REQUIRE([gl_EXTERN_INLINE])
  gl_FUNC_PTHREAD_SIGMASK
  gl_CONDITIONAL([GL_COND_OBJ_PTHREAD_SIGMASK],
                 [test $HAVE_PTHREAD_SIGMASK = 0 || test $REPLACE_PTHREAD_SIGMASK = 1])
  AM_COND_IF([GL_COND_OBJ_PTHREAD_SIGMASK], [
    gl_PREREQ_PTHREAD_SIGMASK
  ])
  gl_SIGNAL_MODULE_INDICATOR([pthread_sigmask])
  gl_SIGNAL_H
  gl_SIGNAL_H_REQUIRE_DEFAULTS
  AC_PROG_MKDIR_P
  gl_THREAD
  AC_REQUIRE([gl_THREADLIB])
  AC_REQUIRE([AC_CANONICAL_HOST])
  gl_CONDITIONAL([GL_COND_OBJ_WINDOWS_THREAD],
                 [case "$host_os" in mingw* | windows*) true;; *) false;; esac])
  AC_REQUIRE([AC_CANONICAL_HOST])
  gl_CONDITIONAL([GL_COND_OBJ_WINDOWS_TLS],
                 [case "$host_os" in mingw* | windows*) true;; *) false;; esac])
  # End of code from modules
  m4_ifval(gttgl_LIBSOURCES_LIST, [
    m4_syscmd([test ! -d ]m4_defn([gttgl_LIBSOURCES_DIR])[ ||
      for gl_file in ]gttgl_LIBSOURCES_LIST[ ; do
        if test ! -r ]m4_defn([gttgl_LIBSOURCES_DIR])[/$gl_file ; then
          echo "missing file ]m4_defn([gttgl_LIBSOURCES_DIR])[/$gl_file" >&2
          exit 1
        fi
      done])dnl
      m4_if(m4_sysval, [0], [],
        [AC_FATAL([expected source file, required through AC_LIBSOURCES, not found])])
  ])
  m4_popdef([GL_MODULE_INDICATOR_PREFIX])
  m4_popdef([GL_MACRO_PREFIX])
  m4_popdef([gttgl_LIBSOURCES_DIR])
  m4_popdef([gttgl_LIBSOURCES_LIST])
  m4_popdef([AC_LIBSOURCES])
  m4_popdef([AC_REPLACE_FUNCS])
  m4_popdef([AC_LIBOBJ])
  AC_CONFIG_COMMANDS_PRE([
    gttgl_libobjs=
    gttgl_ltlibobjs=
    gttgl_libobjdeps=
    gttgl_libtestsgnu_libobjs=
    gttgl_libtestsgnu_ltlibobjs=
    gttgl_libtestsgnu_libobjdeps=
    if test -n "$gttgl_LIBOBJS"; then
      # Remove the extension.
changequote(,)dnl
      sed_drop_objext='s/\.o$//;s/\.obj$//'
      sed_dirname1='s,//*,/,g'
      sed_dirname2='s,\(.\)/$,\1,'
      sed_dirname3='s,[^/]*$,,'
      sed_basename1='s,.*/,,'
changequote([, ])dnl
      for i in `for i in $gttgl_LIBOBJS; do echo "$i"; done | sed -e "$sed_drop_objext" | sort | uniq`; do
        gttgl_libobjs="$gttgl_libobjs $i.$ac_objext"
        gttgl_ltlibobjs="$gttgl_ltlibobjs $i.lo"
        i_dir=`echo "$i" | sed -e "$sed_dirname1" -e "$sed_dirname2" -e "$sed_dirname3"`
        i_base=`echo "$i" | sed -e "$sed_basename1"`
        gttgl_libtestsgnu_libobjs="$gttgl_libtestsgnu_libobjs $i_dir""libtestsgnu_a-$i_base.$ac_objext"
        gttgl_libtestsgnu_ltlibobjs="$gttgl_libtestsgnu_ltlibobjs $i_dir""libtestsgnu_la-$i_base.lo"
        gttgl_libobjdeps="$gttgl_libobjdeps $i_dir\$(DEPDIR)/$i_base.Po"
        gttgl_libtestsgnu_libobjdeps="$gttgl_libtestsgnu_libobjdeps $i_dir\$(DEPDIR)/libtestsgnu_a-$i_base.Po"
      done
    fi
    AC_SUBST([gttgl_LIBOBJS], [$gttgl_libobjs])
    AC_SUBST([gttgl_LTLIBOBJS], [$gttgl_ltlibobjs])
    AC_SUBST([gttgl_LIBOBJDEPS], [$gttgl_libobjdeps])
    AC_SUBST([gttgl_libtestsgnu_LIBOBJS], [$gttgl_libtestsgnu_libobjs])
    AC_SUBST([gttgl_libtestsgnu_LTLIBOBJS], [$gttgl_libtestsgnu_ltlibobjs])
    AC_SUBST([gttgl_libtestsgnu_LIBOBJDEPS], [$gttgl_libtestsgnu_libobjdeps])
  ])
  gltests_libdeps=
  gltests_ltlibdeps=
  m4_pushdef([AC_LIBOBJ], m4_defn([gttgltests_LIBOBJ]))
  m4_pushdef([AC_REPLACE_FUNCS], m4_defn([gttgltests_REPLACE_FUNCS]))
  m4_pushdef([AC_LIBSOURCES], m4_defn([gttgltests_LIBSOURCES]))
  m4_pushdef([gttgltests_LIBSOURCES_LIST], [])
  m4_pushdef([gttgltests_LIBSOURCES_DIR], [])
  m4_pushdef([GL_MACRO_PREFIX], [gttgltests])
  m4_pushdef([GL_MODULE_INDICATOR_PREFIX], [GL_GTTGL])
  gl_COMMON
  gl_source_base='tests'
  gl_source_base_prefix=
changequote(,)dnl
  gttgltests_WITNESS=IN_`echo "${PACKAGE-$PACKAGE_TARNAME}" | LC_ALL=C tr abcdefghijklmnopqrstuvwxyz ABCDEFGHIJKLMNOPQRSTUVWXYZ | LC_ALL=C sed -e 's/[^A-Z0-9_]/_/g'`_GNULIB_TESTS
changequote([, ])dnl
  AC_SUBST([gttgltests_WITNESS])
  gl_module_indicator_condition=$gttgltests_WITNESS
  m4_pushdef([gl_MODULE_INDICATOR_CONDITION], [$gl_module_indicator_condition])
  m4_popdef([gl_MODULE_INDICATOR_CONDITION])
  m4_ifval(gttgltests_LIBSOURCES_LIST, [
    m4_syscmd([test ! -d ]m4_defn([gttgltests_LIBSOURCES_DIR])[ ||
      for gl_file in ]gttgltests_LIBSOURCES_LIST[ ; do
        if test ! -r ]m4_defn([gttgltests_LIBSOURCES_DIR])[/$gl_file ; then
          echo "missing file ]m4_defn([gttgltests_LIBSOURCES_DIR])[/$gl_file" >&2
          exit 1
        fi
      done])dnl
      m4_if(m4_sysval, [0], [],
        [AC_FATAL([expected source file, required through AC_LIBSOURCES, not found])])
  ])
  m4_popdef([GL_MODULE_INDICATOR_PREFIX])
  m4_popdef([GL_MACRO_PREFIX])
  m4_popdef([gttgltests_LIBSOURCES_DIR])
  m4_popdef([gttgltests_LIBSOURCES_LIST])
  m4_popdef([AC_LIBSOURCES])
  m4_popdef([AC_REPLACE_FUNCS])
  m4_popdef([AC_LIBOBJ])
  AC_CONFIG_COMMANDS_PRE([
    gttgltests_libobjs=
    gttgltests_ltlibobjs=
    gttgltests_libobjdeps=
    gttgltests_libtestsgnu_libobjs=
    gttgltests_libtestsgnu_ltlibobjs=
    gttgltests_libtestsgnu_libobjdeps=
    if test -n "$gttgltests_LIBOBJS"; then
      # Remove the extension.
changequote(,)dnl
      sed_drop_objext='s/\.o$//;s/\.obj$//'
      sed_dirname1='s,//*,/,g'
      sed_dirname2='s,\(.\)/$,\1,'
      sed_dirname3='s,[^/]*$,,'
      sed_basename1='s,.*/,,'
changequote([, ])dnl
      for i in `for i in $gttgltests_LIBOBJS; do echo "$i"; done | sed -e "$sed_drop_objext" | sort | uniq`; do
        gttgltests_libobjs="$gttgltests_libobjs $i.$ac_objext"
        gttgltests_ltlibobjs="$gttgltests_ltlibobjs $i.lo"
        i_dir=`echo "$i" | sed -e "$sed_dirname1" -e "$sed_dirname2" -e "$sed_dirname3"`
        i_base=`echo "$i" | sed -e "$sed_basename1"`
        gttgltests_libtestsgnu_libobjs="$gttgltests_libtestsgnu_libobjs $i_dir""libtestsgnu_a-$i_base.$ac_objext"
        gttgltests_libtestsgnu_ltlibobjs="$gttgltests_libtestsgnu_ltlibobjs $i_dir""libtestsgnu_la-$i_base.lo"
        gttgltests_libobjdeps="$gttgltests_libobjdeps $i_dir\$(DEPDIR)/$i_base.Po"
        gttgltests_libtestsgnu_libobjdeps="$gttgltests_libtestsgnu_libobjdeps $i_dir\$(DEPDIR)/libtestsgnu_a-$i_base.Po"
      done
    fi
    AC_SUBST([gttgltests_LIBOBJS], [$gttgltests_libobjs])
    AC_SUBST([gttgltests_LTLIBOBJS], [$gttgltests_ltlibobjs])
    AC_SUBST([gttgltests_LIBOBJDEPS], [$gttgltests_libobjdeps])
    AC_SUBST([gttgltests_libtestsgnu_LIBOBJS], [$gttgltests_libtestsgnu_libobjs])
    AC_SUBST([gttgltests_libtestsgnu_LTLIBOBJS], [$gttgltests_libtestsgnu_ltlibobjs])
    AC_SUBST([gttgltests_libtestsgnu_LIBOBJDEPS], [$gttgltests_libtestsgnu_libobjdeps])
  ])
  AC_REQUIRE([gl_CC_GNULIB_WARNINGS])
  LIBTESTSGNU_LIBDEPS="$gl_libdeps"
  AC_SUBST([LIBTESTSGNU_LIBDEPS])
  LIBTESTSGNU_LTLIBDEPS="$gl_ltlibdeps"
  AC_SUBST([LIBTESTSGNU_LTLIBDEPS])
])

# Like AC_LIBOBJ, except that the module name goes
# into gttgl_LIBOBJS instead of into LIBOBJS.
AC_DEFUN([gttgl_LIBOBJ], [
  AS_LITERAL_IF([$1], [gttgl_LIBSOURCES([$1.c])])dnl
  gttgl_LIBOBJS="$gttgl_LIBOBJS $1.$ac_objext"
])

# Like AC_REPLACE_FUNCS, except that the module name goes
# into gttgl_LIBOBJS instead of into LIBOBJS.
AC_DEFUN([gttgl_REPLACE_FUNCS], [
  m4_foreach_w([gl_NAME], [$1], [AC_LIBSOURCES(gl_NAME[.c])])dnl
  AC_CHECK_FUNCS([$1], , [gttgl_LIBOBJ($ac_func)])
])

# Like AC_LIBSOURCES, except the directory where the source file is
# expected is derived from the gnulib-tool parameterization,
# and alloca is special cased (for the alloca-opt module).
# We could also entirely rely on EXTRA_lib..._SOURCES.
AC_DEFUN([gttgl_LIBSOURCES], [
  m4_foreach([_gl_NAME], [$1], [
    m4_if(_gl_NAME, [alloca.c], [], [
      m4_define([gttgl_LIBSOURCES_DIR], [tests/gnulib-lib])
      m4_append([gttgl_LIBSOURCES_LIST], _gl_NAME, [ ])
    ])
  ])
])

# Like AC_LIBOBJ, except that the module name goes
# into gttgltests_LIBOBJS instead of into LIBOBJS.
AC_DEFUN([gttgltests_LIBOBJ], [
  AS_LITERAL_IF([$1], [gttgltests_LIBSOURCES([$1.c])])dnl
  gttgltests_LIBOBJS="$gttgltests_LIBOBJS $1.$ac_objext"
])

# Like AC_REPLACE_FUNCS, except that the module name goes
# into gttgltests_LIBOBJS instead of into LIBOBJS.
AC_DEFUN([gttgltests_REPLACE_FUNCS], [
  m4_foreach_w([gl_NAME], [$1], [AC_LIBSOURCES(gl_NAME[.c])])dnl
  AC_CHECK_FUNCS([$1], , [gttgltests_LIBOBJ($ac_func)])
])

# Like AC_LIBSOURCES, except the directory where the source file is
# expected is derived from the gnulib-tool parameterization,
# and alloca is special cased (for the alloca-opt module).
# We could also entirely rely on EXTRA_lib..._SOURCES.
AC_DEFUN([gttgltests_LIBSOURCES], [
  m4_foreach([_gl_NAME], [$1], [
    m4_if(_gl_NAME, [alloca.c], [], [
      m4_define([gttgltests_LIBSOURCES_DIR], [tests])
      m4_append([gttgltests_LIBSOURCES_LIST], _gl_NAME, [ ])
    ])
  ])
])

# This macro records the list of files which have been installed by
# gnulib-tool and may be removed by future gnulib-tool invocations.
AC_DEFUN([gttgl_FILE_LIST], [
  lib/arg-nonnull.h
  lib/c++defs.h
  lib/glthread/thread.c
  lib/glthread/thread.h
  lib/glthread/threadlib.c
  lib/pthread_sigmask.c
  lib/signal.in.h
  lib/warn-on-use.h
  lib/windows-thread.c
  lib/windows-thread.h
  lib/windows-tls.c
  lib/windows-tls.h
  m4/00gnulib.m4
  m4/extern-inline.m4
  m4/gnulib-common.m4
  m4/pid_t.m4
  m4/pthread_sigmask.m4
  m4/signal_h.m4
  m4/thread.m4
  m4/threadlib.m4
  m4/warn-on-use.m4
  m4/zzgnulib.m4
])
